'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _bluebird = require('bluebird');

require('source-map-support/register');

var _nextion = require('./nextion');

var _protocol = require('./protocol');

var _uart = require('./uart');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_nextion.Nextion.from = _nextion.Nextion.create = function () {
  var _ref = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee(port) {
    var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var uart;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _uart.UART.from(port, opts);

          case 2:
            uart = _context.sent;
            return _context.abrupt('return', new _nextion.Nextion(uart));

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function from(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return from;
}();

_nextion.Nextion.fromSerial = function () {
  var _ref2 = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee2(serialPort) {
    var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var uart;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return _uart.UART.fromSerial(serialPort, opts);

          case 2:
            uart = _context2.sent;
            return _context2.abrupt('return', new _nextion.Nextion(uart));

          case 4:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  function fromSerial(_x4, _x5) {
    return _ref2.apply(this, arguments);
  }

  return fromSerial;
}();

_nextion.Nextion.fromPort = function () {
  var _ref3 = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee3(portName) {
    var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    var uart;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return _uart.UART.fromPort(portName, opts);

          case 2:
            uart = _context3.sent;
            return _context3.abrupt('return', new _nextion.Nextion(uart));

          case 4:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  function fromPort(_x7, _x8) {
    return _ref3.apply(this, arguments);
  }

  return fromPort;
}();

_nextion.Nextion.NextionProtocol = _protocol.NextionProtocol;
_nextion.Nextion.UART = _uart.UART;

module.exports = _nextion.Nextion;
//# sourceMappingURL=index.js.map