'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.System = exports.SYSTEM_GLOBAL_VARIABLES = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _bluebird = require('bluebird');

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _events = require('events');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isUnsignedInteger = _fp2.default.overEvery([_fp2.default.isNumber, _fp2.default.isFinite, _fp2.default.gte(0)]);

var SYSTEM_GLOBAL_VARIABLES = exports.SYSTEM_GLOBAL_VARIABLES = ['sys0', 'sys1', 'sys2'];

var System = exports.System = function (_EventEmitter) {
  (0, _inherits3.default)(System, _EventEmitter);

  function System(uart) {
    (0, _classCallCheck3.default)(this, System);

    var _this = (0, _possibleConstructorReturn3.default)(this, (System.__proto__ || (0, _getPrototypeOf2.default)(System)).call(this));

    _this.uart = uart;
    return _this;
  }

  (0, _createClass3.default)(System, [{
    key: 'setGlobalVariable',
    value: function () {
      var _ref = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee(name, value) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (_fp2.default.includes(SYSTEM_GLOBAL_VARIABLES, name)) {
                  _context.next = 2;
                  break;
                }

                throw new Error(`"name" must be one of: ${SYSTEM_GLOBAL_VARIABLES.join(', ')}`);

              case 2:
                if (isUnsignedInteger(value)) {
                  _context.next = 4;
                  break;
                }

                throw new Error('"value" must be an unsigned integer <= 4294967295');

              case 4:
                _context.next = 6;
                return this.uart.setValue(name, value);

              case 6:
                return _context.abrupt('return', _context.sent);

              case 7:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function setGlobalVariable(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return setGlobalVariable;
    }()
  }, {
    key: 'setRandomRange',
    value: function () {
      var _ref2 = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee2(min, max) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (isUnsignedInteger(min)) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('"min" must be an unsigned integer <= 4294967295');

              case 2:
                if (isUnsignedInteger(max)) {
                  _context2.next = 4;
                  break;
                }

                throw new Error('"max" must be an unsigned integer <= 4294967295');

              case 4:
                _context2.next = 6;
                return this.uart.request(`ranset ${min},${max}`);

              case 6:
                return _context2.abrupt('return', _context2.sent);

              case 7:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function setRandomRange(_x3, _x4) {
        return _ref2.apply(this, arguments);
      }

      return setRandomRange;
    }()
  }, {
    key: 'random',
    value: function () {
      var _ref3 = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee3() {
        var min = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
        var max = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (!(max < min)) {
                  _context3.next = 2;
                  break;
                }

                throw new Error('"max" cannot be less than "min"');

              case 2:
                if (!(min > 0 || max > 0)) {
                  _context3.next = 5;
                  break;
                }

                _context3.next = 5;
                return this.setRandomRange(min, max);

              case 5:
                _context3.next = 7;
                return this.uart.request('rand');

              case 7:
                return _context3.abrupt('return', _context3.sent);

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function random(_x5, _x6) {
        return _ref3.apply(this, arguments);
      }

      return random;
    }()
  }, {
    key: 'sleep',
    value: function () {
      var _ref4 = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee4() {
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.uart.request('sleep=1');

              case 2:
                return _context4.abrupt('return', _context4.sent);

              case 3:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function sleep() {
        return _ref4.apply(this, arguments);
      }

      return sleep;
    }()
  }, {
    key: 'wake',
    value: function () {
      var _ref5 = (0, _bluebird.coroutine)(_regenerator2.default.mark(function _callee5() {
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return this.uart.request('sleep=0');

              case 2:
                return _context5.abrupt('return', _context5.sent);

              case 3:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function wake() {
        return _ref5.apply(this, arguments);
      }

      return wake;
    }()
  }]);
  return System;
}(_events.EventEmitter);
//# sourceMappingURL=system.js.map